-- Common Help function for plugins by David Down
-- coding: utf-8
local function printh(text) print("<rgb=#00FF00>"..text.."</rgb>") end

function Help(help,arg)
    local pre = '/'..help.pre
    if not arg then
        print(help.help)
    elseif arg=='?' then
        printh("Possible command arguments:")
        for name,text in pairs(help.arg) do
            if #name>0 then print(name..' - '..text) end
        end
    elseif arg=='??' then
        printh("Possible commands:")
        local str = help.arg[''] or help.arg[' ']
        if str then print(pre..' - '..str) end
        for name,val in pairs(help.cmd) do
            local str,text = name,val
            if type(val)=="table" then 
                str = str.." ?"
                text = val[" "] 
            end
            print('/'..str..' - '..text)
        end
    elseif help.cmd and help.cmd[arg] then
        if type(help.cmd[arg]) == "table" then
            printh("Possible '/"..arg.."' arguments:")
            for name,text in pairs(help.cmd[arg]) do
                print(name..' - '..text)
            end
        else print(arg..' - '..help.cmd[arg]) end
    else print("Enter '"..pre.." ?' for arguments, '"..pre.."?' for commands") end
end

function HelpCmd(cmd,args,help)
    local pre = help.pre
	if cmd==pre and (args=="help" or args=="?" or args=="??") then
		Help(help,args)
		return true
	end
	if cmd==pre..'?' then
		Help(help,"??")
		return true
	end
	if args=="?" then
		Help(help,cmd)
		return true
	end
end